package co.nubilus.util

import java.util.concurrent._
import _root_.scala.actors.{Actor, Exit,TIMEOUT}
import _root_.scala.actors.Actor._
import java.util.concurrent.Executors

object ActorPing {
	
  	private lazy val sched = Executors.newSingleThreadScheduledExecutor(SchedulerThreadFactory)
  	
  	def shutdown = {
  		sched.shutdownNow
  	}
  	
  	def schedule(f: => Unit, delay:Long) {
  		sched.schedule(new Runnable {
  			def run = {
  					actors.Scheduler.execute(f) 
  			}
		}, delay, TimeUnit.MILLISECONDS);
  	}
}

private object SchedulerThreadFactory extends ThreadFactory {
	val threadFactory = Executors.defaultThreadFactory()
	def newThread(r: Runnable): Thread = {
		val thread = threadFactory.newThread(r)
		thread.setDaemon(true)
		thread
	}
}