package co.nubilus.servlet

import javax.servlet.{ServletContextListener,ServletContextEvent}
import javax.ejb._
import co.nubilus.util.ActorPing
import co.nubilus.bar.BarLocal
import scala.actors.{Actor,Exit}
import scala.actors.Actor._

class StartupShutdown extends javax.servlet.ServletContextListener {

	// The messages
	private case class Reload()

	private val frameInterval = 55000
	
	@EJB(name="bar")
	private var fm:BarLocal = null
	
	private val barActor: Actor = actor {
			loop {
				receive {
					case Reload =>
						println("Bar Reference: "+fm)
						fm.reload
						ActorPing.schedule({ barActor ! Reload }, frameInterval) // schedule next check
					case Exit => {
						ActorPing.shutdown
						exit()
					}
				}
			}
		}
	
	override def contextInitialized( sce: ServletContextEvent ) {
		barActor ! Reload
	}

	override def contextDestroyed( sce: ServletContextEvent ) {	
		barActor ! Exit
	}
	
}