package co.nubilus.servlet

import javax.servlet.{ServletContextListener,ServletContextEvent}
import javax.ejb._
import co.nubilus.util.ActorPing
import co.nubilus.foo.FooLocal
import scala.actors.{Actor,Exit}
import scala.actors.Actor._

class StartupShutdown extends javax.servlet.ServletContextListener {

	// The messages
	private case class Reload()

	private val frameInterval = 15000
	
	@EJB(name="foo")
	private var fm:FooLocal = null
	
	private val fooActor: Actor = actor {
			loop {
				receive {
					case Reload =>
						println("Foo reference: "+fm)
						fm.reload
						ActorPing.schedule({ fooActor ! Reload }, frameInterval) // schedule next check
					case Exit => {
						ActorPing.shutdown
						exit()
					}
				}
			}
		}
	
	override def contextInitialized( sce: ServletContextEvent ) {
		fooActor ! Reload
	}

	override def contextDestroyed( sce: ServletContextEvent ) {	
		fooActor ! Exit
	}
	
}